package xic;

import java.util.ArrayList;
import java.util.List;

import edu.cornell.cs.cs4120.xi.CompilationException;

/**
 * Class used to hold errors encountered while type-checking.
 */
public class ErrorSink {
	private List<CompilationException> errors;

	public ErrorSink() {	
		errors = new ArrayList<CompilationException>();
	}
	
	public void addError(CompilationException error) {
		errors.add(error);
	}

	public void addErrors(ErrorSink errorSink) {
		errors.addAll(errorSink.errors);
	}

	public boolean hasErrors() {
		return errors.size() > 0;
	}
	
	public List<CompilationException> getErrors() {
		return errors;
	}
}
