package xic.ast;

import edu.cornell.cs.cs4120.xi.Position;

/**
 * Base class of all expressions
 */
public abstract class Expr extends ASTNode implements Typed {
	protected TypeNode type;
	protected DataSource dataSource;

	public Expr(Position pos) {
		super(pos);
	}
	
	public TypeNode getType() {
		return type;
	}

	public Typed setType(TypeNode type) {
		if (type == this.type)
			return this;

		Expr e = (Expr) copy();
		e.type = type;
		return e;
	}

	public DataSource getDataSource() {
		return dataSource;
	}

	public Typed setDataSource(DataSource dataSource) {
		if (dataSource == this.dataSource)
			return this;

		Expr e = (Expr) copy();
		e.dataSource = dataSource;
		return e;
	}
}
