package xic.codegen.matchers;

import java.util.ArrayList;
import java.util.List;

import xic.codegen.AbstractTile;
import xic.codegen.InstrList;
import xic.codegen.Matcher;
import xic.codegen.Tile;
import xic.codegen.Tiler;
import xic.ir.IRNode;
import xic.ir.IRSeq;
import xic.ir.IRStmt;
import xic.ir.NameGenerator;


public class SeqMatcher implements Matcher {
	protected static class SeqTile extends AbstractTile {
		public SeqTile(List<Tile> children) {
			this.children.addAll(children);
		}

		public int localCost() {
			return 0;
		}

		public String translate(InstrList il, NameGenerator ng) {
			for (Tile tile : children)
				tile.translate(il, ng);
			return null;
		}
	};

	public Tile match(IRNode node, Tiler tiler) {
		if (!(node instanceof IRSeq))
			return null;

		IRSeq seq = (IRSeq) node;
		List<Tile> children = new ArrayList<Tile>();
		for (IRStmt stmt : seq.stmts())
			children.add(tiler.tile(stmt));

		return new SeqTile(children);
	}
}
