package xic.ir;

import java.util.Set;

import xic.ast.ASTNode;
import xic.ast.Copyable;
import xic.visitors.NodeVisitor;


public class IRConst extends IRExpr {
	private long value;
	
	public IRConst(long value) {
		this.value = value;
	}
	
	public long value() {
		return value;
	}

	public ASTNode visitChildren(NodeVisitor v) {
		return this;
	}

	public String label() {
		return "CONST(" + value + ")";
	}

	public int computeMaximumCallArguments() {
		return 0;
	}

	public int computeMaximumCallResults() {
		return 0;		
	}

	public boolean containsCalls() {
		return false;
	}

	public boolean containsMemReads() {
		return false;
	}

	public boolean containsNonParamMemReads() {
		return false;
	}

	public boolean containsMemWrites() {
		return false;
	}

	public void findReadTemps(Set<String> tempNames) {
	}
	
	public void findWrittenTemps(Set<String> tempNames) {
	}	

	public int nodeCount() {
		return 1;
	}

	public Copyable copy() {
		return new IRConst(value);
	}
	
	public Copyable deepCopy() {
		return new IRConst(value);
	}
	
	public boolean equalsTree(Object object) {
		if (!(object instanceof IRConst))
			return false;
		return ((IRConst) object).value == value;
	}
	
	public int treeHashCode() {
		return (int) value;
	}
}
