package xic.ir;

import java.util.Set;

import xic.ast.ASTNode;
import xic.ast.Copyable;
import xic.visitors.NodeVisitor;


public class IRTemp extends IRExpr {
	private String name;

	public IRTemp(String name) {
		this.name = name;
	}
	
	public String name() {
		return name;
	}

	public ASTNode visitChildren(NodeVisitor v) {
		return this;
	}

	public String label() {
		return "TEMP(" + name + ")";
	}
	
	public boolean containsCalls() {
		return false;
	}

	public boolean containsMemReads() {
		return false;
	}
	
	public boolean containsNonParamMemReads() {
		return false;
	}

	public boolean containsMemWrites() {
		return false;
	}

	public void findReadTemps(Set<String> tempNames) {
		tempNames.add(name);
	}

	public void findWrittenTemps(Set<String> tempNames) {
	}
	
	public void findReadParams(Set<String> tempNames) {
	}

	public int computeMaximumCallArguments() {
		return 0;
	}

	public int computeMaximumCallResults() {
		return 0;		
	}

	public int nodeCount() {
		return 1;
	}

	public Copyable copy() {
		return new IRTemp(name);
	}

	public Copyable deepCopy() {
		return new IRTemp(name);
	}

	public boolean equalsTree(Object object) {
		if (!(object instanceof IRTemp))
			return false;
		return ((IRTemp) object).name.equals(name);
	}
	
	public int treeHashCode() {
		return name.hashCode();
	}

	public void setName(String n) {
		this.name = n;
	}

}
