package xic.lexer;

import xic.Configuration;
import edu.cornell.cs.cs4120.xi.CompilationException;
import edu.cornell.cs.cs4120.xi.Position;

public class IntegerToken extends BaseToken {
	protected long intValue;
	
	public IntegerToken(int type, String value, String unit, int line, int column, int length) {
		super(type, value, unit, line, column, length);
		try {
			if (Configuration.WORD_SIZE == 8)
				intValue = Long.parseLong(value);
			else
				intValue = (long) Integer.parseInt(value);
		} catch (NumberFormatException ex) {
			throw new CompilationException("Encountered an illegal number token: '" + value + "'",
					position());
		}
	}

	public IntegerToken(int type, Position position, String value) {
		super(type, position, value);
		try {
			if (Configuration.WORD_SIZE == 8)
				intValue = Long.parseLong(value);
			else
				intValue = (long) Integer.parseInt(value);
		} catch (NumberFormatException ex) {
			throw new CompilationException("Encountered an illegal number token: '" + value + "'",
					position());
		}
	}
	
	public long intValue() {
		return intValue;
	}
	
	public boolean equals(Object obj) {
		if (obj.getClass() != IntegerToken.class)
			return false;
		IntegerToken other = (IntegerToken) obj;
		return super.equals(other) && other.intValue == intValue;
	}

	public int hashCode() {
		return 37*super.hashCode() + (int) intValue;
	}
}
